
% Apply curvature estimation to concentric rings.
%

% Construct a test image of concentric rings
[x1 x2] = ndgrid(-128:127,-128:127);
input_im = sqrt(x1.*x1 + x2.*x2);
input_im = sin(0.5*input_im);

% Apply curvature estimators based on parabolic and circular models
[orientation_par_im, curvature_par_im, confidence_par_im] = curvature_parabolic(input_im, 1.5, 5);
[orientation_cir_im, curvature_cir_im, confidence_cir_im] = curvature_circular (input_im, 1.5, 5);

% Compute radius of curvature for bothy estimators
% radius_of_curvature = 1 / curvature; ( < 200 is to clip the image for visualisation)
radius_par_im = (1 ./ abs(curvature_par_im)) .* ((1 ./ abs(curvature_par_im)) < 200);
radius_cir_im = (1 ./ abs(curvature_cir_im)) .* ((1 ./ abs(curvature_cir_im)) < 200);

% Display
figure(1); imagesc(input_im);
figure(2); imagesc(radius_par_im );
figure(3); imagesc(confidence_par_im);
figure(4); imagesc(radius_cir_im );
figure(5); imagesc(confidence_cir_im);
